#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "include/irc.h"
#include "include/ircaux.h"
#include "include/status.h"
#include "include/screen.h"
#include "include/vars.h"
#include "include/misc.h"
#include "include/output.h"

#define HINT_LOADED "*** %W<%GHint shared libarary loaded%W>"
#define getrandom(min, max) ((rand() % (int)(((max)+1) - (min))) + (min))

int max_hints;
char hint_file[BIG_BUFFER_SIZE];

char *cp(char *fmt) { return (convert_output_format(fmt, NULL, NULL)); }

char Hint_version[] = "0.01";

/* prototypes */
void hint _((IrcCommandDll *interp, char *command, char *args, char *subargs));
int Hint_Init(IrcCommandDll **interp);

char *Hint_Version(IrcCommandDll **interp)
{
	return Hint_version;
}

int Hint_Init(IrcCommandDll **interp)
{
  IrcCommandDll *new;
  FILE *fp;
  char *home = getenv("HOME");
  char hint_buf[BIG_BUFFER_SIZE]; /* max length of one hint */
  
  new = (IrcCommandDll *)new_malloc(sizeof(IrcCommandDll));
  new->name = m_strdup("hint");
  new->func = hint;
  add_to_list((List **)interp, (List *)new);
  srand(time(NULL));
  put_it("%s", cp(HINT_LOADED));
  
  sprintf(hint_file, "%s/.BitchX/BitchX.hints", home);
  max_hints=0;
  fp = fopen(hint_file, "r");
  if (fp!=NULL)
  {
    while (fgets(hint_buf, 128, fp)!=NULL) max_hints++;
    fclose(fp);
    put_it("%s (using %d hints)", cp("*** %W<%Ghint%W>%n"), max_hints);
    max_hints--;
  } else
    put_it("%s (%s)", cp("*** %W<%Ghint%W>%n: Hint file not found"), hint_file);
    
  return 0;
}

void hint _((IrcCommandDll *interp, char *command, char *args, char *subargs))
{
  int hint_no;
  FILE *fp;
  int i;
  char hint_buf[BIG_BUFFER_SIZE]; /* max length of one hint */
  
  if (max_hints <= 0)
  {
    put_it("%s", cp("*** %W<%Ghint%W>%n: No %s avaible. (try /re-hint)"), max_hints != 1 ? "hints":"hint");
    return;
  }
  
  hint_no = getrandom(0, max_hints);
  /* put_it("Selecting %d. hint.", hint_no); */
  
  fp = fopen(hint_file, "r");
  for (i=0;i<=hint_no;i++) fgets(hint_buf, 128, fp);
  chop(hint_buf, 1);
  put_it("%s", cp(hint_buf));
    
  fclose(fp);
}
  